/*							*/
/*  Initiate mpeg/vcd rom dump, then try communicating  */
/*  with the commlink program                           */
/*  -Written by Cyber Warrior X                         */
/*							*/

#include    "sgl_cd.h"
#include    "sega_sys.h"
#include    "comms.h"

//////////////////////////////////////////////////////////////////////////////

#define SYS_MPEGCHECK(i, i2, i3) \
        ((**(int(**)(int, int, int))0x6000298)(i, i2, i3))

//////////////////////////////////////////////////////////////////////////////

void ss_main(void)
{
   Sint32 ret;
   char tempstr[128];

   slInitSystem(TV_320x224,NULL,1);

   slScrAutoDisp(NBG0ON);

   if ((ret = SYS_MPEGCHECK(0, 128, 0x06080000)) < 0)
//   if ((ret = SYS_MPEGCHECK(128, 128, 0x06080000)) < 0)
   {
      sprintf(tempstr, "SYS_MPEGCHECK < 0(%d)", ret);
      slPrint(tempstr, slLocate(2, 22));
   }
   else
   {
      sprintf(tempstr, "bytes read = %d", ret);
      slPrint(tempstr, slLocate(2, 22));
   }

   slPrint("COMPLETE: Waiting for commlink...", slLocate(2, 1));

   for(;;)
   {
      unsigned char cmdbyte=0;

      slSynch();

      par_sync();
      slPrint("par synched", slLocate(2, 2));
      cmdbyte = comms_exchange_byte(0);
      sprintf(tempstr, "retrieved command byte(%d)", cmdbyte);
      slPrint(tempstr, slLocate(2, 3));

      switch (cmdbyte)
      {
         case 1:
         {
            unsigned long addr;
            unsigned long length;
            unsigned char *buffer;
            unsigned long i;
            unsigned char chksum=0;

            // I'm supposed to send R9 here, oh well
            comms_send_long(0);

            for (;;)
            {
               // Download Memory
               addr = comms_get_long();
               length = comms_get_long();
               buffer = (unsigned char *)addr;

               sprintf(tempstr, "retrieve address and length(%08x, %08x)", addr, length);
               slPrint(tempstr, slLocate(2, 4));

               if (length == 0)
               {
                  comms_exchange_byte('O');
                  comms_exchange_byte('K');
                  break;
               }

               sprintf(tempstr, "Doing data transfer");
               slPrint(tempstr, slLocate(2, 5));

               // data transfer
               for (i = 0; i < length; i++)
               {
                 comms_exchange_byte(buffer[i]);
                 chksum+=buffer[i];
               }

               sprintf(tempstr, "data transfer done, checksum = %02x", chksum);
               slPrint(tempstr, slLocate(2, 6));

               comms_exchange_byte(chksum);
            }

            break;
         }
         case 2:
         {
            // unknown
            break;
         }
         case 3:
         {
            // unknown
            break;
         }
         case 4:
         {
            // unknown
            break;
         }
         case 5:
         {
            // unknown
            break;
         }
         case 6:
         {
            // unknown
            break;
         }
         case 7:
         {
            // unknown
            break;
         }
         case 8:
         {
            // Write byte to memory address
            break;
         }
         case 9:
         {
            // Upload, execute data
            break;
         }
      }
   }
}

//////////////////////////////////////////////////////////////////////////////

