
#include "comms.h"

uint8 comms_exchange_byte(uint8 value)
{
    uint8 temp;
    while((COMMS_STAT & 1) == 0);
    temp = COMMS_IN;
    COMMS_OUT = value;
    return temp;
}

void comms_send_word(uint16 data)
{
    comms_exchange_byte(data >> 8);
    comms_exchange_byte(data & 0xFF);
}


void comms_send_long(uint32 data)
{
    comms_exchange_byte(data >> 24);
    comms_exchange_byte((data >> 16) & 0xFF);
    comms_exchange_byte((data >> 8) & 0xFF);
    comms_exchange_byte(data & 0xFF);
}

uint32 comms_get_long(void)
{
    uint32 data = comms_exchange_byte(0) << 24;
    data |= comms_exchange_byte(0) << 16;
    data |= comms_exchange_byte(0) << 8;
    data |= comms_exchange_byte(0);
    return data;
}

/*--------------------------------------------------------------------------*/
/* PC interface functions                                                   */
/*--------------------------------------------------------------------------*/

/*
    Synchronize with PAR 
*/
void par_sync(void)
{
    while (1)
    {
        if (comms_exchange_byte('D') != 'I')
            continue;
        if (comms_exchange_byte('O') == 'N')
            break;
    }
}

